# 2.3.x Stable Releases

See https://www.pantsbuild.org/v2.3/docs/release-notes-2-3 for an overview of the changes in this release series.

## 2.3.3 (Jun 16, 2021)

The fourth stable release of the `2.3.x` series, with no changes since the previous `rc`.

## 2.3.3rc0 (Jun 02, 2021)

### Bug fixes

* Fix `Key` interning race causing `panic while processing panic` failure (Cherry-pick of #12152) ([#12160](https://github.com/pantsbuild/pants/pull/12160))

## 2.3.2 (May 6, 2021)

The third stable release of the `2.3.x` series, with no changes since the previous `rc`.

## 2.3.2rc0 (Apr 29, 2021)

### User API Changes

* Add back `interpreter_constraints` field to `pex_binary` and `python_awslambda` ([#11980](https://github.com/pantsbuild/pants/pull/11980))

## 2.3.1 (Apr 20, 2021)

The second stable release of the `2.3.x` series, with no changes since the previous `rc`.

## 2.3.1rc3 (Apr 14, 2021)

### Bug fixes

* Allow Python files without a file ending (Cherry-pick of #11905) ([#11917](https://github.com/pantsbuild/pants/pull/11917))

* Fix bug in Python 2.7 string dep inference. (Cherry-pick of #11900) ([#11903](https://github.com/pantsbuild/pants/pull/11903))

## 2.3.1rc2 (Apr 10, 2021)

### Bug fixes

* Fix a bug in unicode string dep inference. (cherrypick of #11879) ([#11882](https://github.com/pantsbuild/pants/pull/11882))

### Documentation

* Fix typo in `tags` help message ([#11838](https://github.com/pantsbuild/pants/pull/11838))

## 2.3.1rc1 (Mar 25, 2021)

### Bug fixes

* Upgrade to Pex 2.1.35 to fix interpreter-rexec loop. (cherrypick of #11799) ([#11801](https://github.com/pantsbuild/pants/pull/11801))

* Kill `SETTABLE_ENV_VARS` allow list to allow passing ssh-agent config. (cherrypick of #11743) ([#11791](https://github.com/pantsbuild/pants/pull/11791))

## 2.3.1rc0 (Mar 21, 2021)

### Bug fixes

* Fix remote execution: use `append_only_caches` in Pex processes. (#11760) ([#11765](https://github.com/pantsbuild/pants/pull/11765))

## 2.3.0 (Mar 18, 2021)

The first stable release in the `2.3.x` series, with no changes since the previous rc.

## 2.3.0rc4 (Mar 17, 2021)

### Bug fixes

* Fix a deadlock involving `scheduler.all_digests`, and add a note. (cherrypick of #11723) ([#11726](https://github.com/pantsbuild/pants/pull/11726))

* Upgrade to Pex 2.1.34 to pull in a fix for an import race. (#11711) ([#11713](https://github.com/pantsbuild/pants/pull/11713))

## 2.3.0rc3 (Mar 12, 2021)

### Bug fixes

* Fix PYTHONPATH not including protobuf targets using `python_source_root`  (#11673) ([#11675](https://github.com/pantsbuild/pants/pull/11675))

* Do not interpret passthrough args. (cherrypick of #11656) ([#11660](https://github.com/pantsbuild/pants/pull/11660))

## 2.3.0rc2 (Mar 08, 2021)

### Bug fixes

* Upgrade to Pex 2.1.33 to fix `et-xmlfile` issue. (Cherry-pick of #11647) ([#11651](https://github.com/pantsbuild/pants/pull/11651))

* Ensure that ancestor files at the buildroot are found (Cherry-pick of #11632) ([#11637](https://github.com/pantsbuild/pants/pull/11637))
  
* Handle two edge cases with `./pants tailor` (Cherry-pick of #11625) ([#11637](https://github.com/pantsbuild/pants/pull/11637))

## 2.3.0rc1 (Feb 25, 2021)

### Bug fixes

* Upgrade Pex to 2.1.32 to fix venv shebangs being too long for some Linux systems. (Cherry-pick of #11604) ([#11606](https://github.com/pantsbuild/pants/pull/11606))

### Documentation

* Less chatty plugin resolution logging (Cherry-pick of #11593) ([#11595](https://github.com/pantsbuild/pants/pull/11595))

## 2.3.0rc0 (Feb 23, 2021)

### New Features

* A `tailor` goal to generate BUILD file targets automatically ([#11517](https://github.com/pantsbuild/pants/pull/11517))

* Generate `protobuf_library` targets with `./pants tailor` ([#11582](https://github.com/pantsbuild/pants/pull/11582))

* Support `--venv` mode for `pex_binary` targets. ([#11510](https://github.com/pantsbuild/pants/pull/11510))

* Auto-discover CA certs if TLS is used and `--remote-ca-certs-path` is unset ([#11572](https://github.com/pantsbuild/pants/pull/11572))

### User API Changes

* Deprecate --setuptools-{entry-point,interpreter-constraints} ([#11539](https://github.com/pantsbuild/pants/pull/11539))

* Deprecate `--remote-store-server` and `--remote-execution-server` in favor of `--remote-store-address` and `--remote-execution-address` ([#11570](https://github.com/pantsbuild/pants/pull/11570))

* Deprecate unused `--remote-store-initial-timeout`, `--remote-store-timeout-multiplier`, `--remote-store-maximum-timeout`, `--remote-store-connection-limit`, and `--remote-store-thread-count` ([#11577](https://github.com/pantsbuild/pants/pull/11577))

* Upgrade Pex to 2.1.31. ([#11588](https://github.com/pantsbuild/pants/pull/11588))

### Bug fixes

* Fix Black to work by default with Python 3.9 ([#11541](https://github.com/pantsbuild/pants/pull/11541))

* Fix MyPy to work by default with Python 3.9 ([#11537](https://github.com/pantsbuild/pants/pull/11537))

### Performance

* Use --venv mode for internal PEXes. ([#11557](https://github.com/pantsbuild/pants/pull/11557))

### Documentation

* Improve error message for unrecognized BUILD file symbols ([#11564](https://github.com/pantsbuild/pants/pull/11564))

## 2.3.0.dev3 (Feb 3, 2021)

### New Features

* Add `--remote-auth-plugin` ([#11503](https://github.com/pantsbuild/pants/pull/11503))

### User API Changes

* Stop pinning `zipp` by default in `[pytest].pytest_plugins` ([#11512](https://github.com/pantsbuild/pants/pull/11512))

* Change default for `[pytest].pytest_plugins` to use pytest-cov 2.11.x ([#11514](https://github.com/pantsbuild/pants/pull/11514))

* Change default versions for `setuptools` options ([#11515](https://github.com/pantsbuild/pants/pull/11515))

### Plugin API Changes

* Upgrade packaging from 20.8 to 20.9 ([#11508](https://github.com/pantsbuild/pants/pull/11508))

## 2.3.0.dev2 (Jan 31, 2021)

### New Features

* Allow specifying files with `--url-template`. ([#11499](https://github.com/pantsbuild/pants/pull/11499))

### User API Changes

* Bump default MyPy version to 0.800 ([#11506](https://github.com/pantsbuild/pants/pull/11506))

* Add `--remote-store-headers` and fix `--remote-execution-headers` to not impact remote caching ([#11501](https://github.com/pantsbuild/pants/pull/11501))

* Deprecate `[python-setup].resolver_version` defaulting to pip legacy resolver ([#11497](https://github.com/pantsbuild/pants/pull/11497))

### Performance

* Make remote cache writes async ([#11479](https://github.com/pantsbuild/pants/pull/11479))

## 2.3.0.dev1 (Jan 21, 2021)

### New Features

* Support Pex CLI `--unzip` and `--include-tools`. ([#11483](https://github.com/pantsbuild/pants/pull/11483))

### User API Changes

* Remove deprecated `--pants-bootstrapdir` and `--pants-configdir` options ([#11491](https://github.com/pantsbuild/pants/pull/11491))

### Plugin API Changes

* Remove `RunInfo` class ([#11456](https://github.com/pantsbuild/pants/pull/11456))

### Bug fixes

* Fix use of remote store when in eager cache mode ([#11468](https://github.com/pantsbuild/pants/pull/11468))

* Workaround Rust 1.49 breaking macOS processes with a materialized argv0 ([#11452](https://github.com/pantsbuild/pants/pull/11452))

### Performance

* Use speculation for remote cache reads ([#11429](https://github.com/pantsbuild/pants/pull/11429))

### Documentation

* Change logging level for Scrubbed PYTHONPATH to be debug ([#11480](https://github.com/pantsbuild/pants/pull/11480))

* Add failure logging to the StoreGCService. ([#11460](https://github.com/pantsbuild/pants/pull/11460))

* Document address storage in AsyncFieldMixin. ([#11448](https://github.com/pantsbuild/pants/pull/11448))

## 2.3.0.dev0 (Jan 10, 2021)

### User API Changes

* Remove support for pex_binary sources. ([#11445](https://github.com/pantsbuild/pants/pull/11445))

* Remove custom targets for Pylint and MyPy. ([#11441](https://github.com/pantsbuild/pants/pull/11441))

* Remove deprecated --pantsd-pailgun-quit-timeout option. ([#11440](https://github.com/pantsbuild/pants/pull/11440))

* Remove DeprecatedRunTracker. ([#11439](https://github.com/pantsbuild/pants/pull/11439))

* Remove deprecated PythonAwsLambda fields. ([#11438](https://github.com/pantsbuild/pants/pull/11438))

### Plugin API Changes

* Remove support for 'Lite' request object hacks. ([#11444](https://github.com/pantsbuild/pants/pull/11444))

* Remove support for docstring help. ([#11442](https://github.com/pantsbuild/pants/pull/11442))

* Remove deprecated v1 Subsystem facilities ([#11424](https://github.com/pantsbuild/pants/pull/11424))

* Remove python workunits ([#11416](https://github.com/pantsbuild/pants/pull/11416))

### Bug fixes

* Add `--remote-cache-eager-fetch` to reduce unreliability ([#11396](https://github.com/pantsbuild/pants/pull/11396))

* Fix older versions of `tar` not working when creating an `archive` ([#11413](https://github.com/pantsbuild/pants/pull/11413))

* Fix `--opt` options in constraints.txt files erroring ([#11407](https://github.com/pantsbuild/pants/pull/11407))

* Move to having the Scheduler directly handle SIGINT to cancel all relevant Sessions. ([#11399](https://github.com/pantsbuild/pants/pull/11399))

### Documentation

* docs: fix simple typo, processs -> process ([#11402](https://github.com/pantsbuild/pants/pull/11402))
